﻿$(document).ready(function () {

    var viewerJ = $('.DicomWebViewer');

    viewerJ.bind("mousedown", userMouseDown);
    viewerJ.bind("mouseup", userMouseUp);
    viewerJ.bind("mousemove", userMouseMove)

    viewerJ.bind("touchstart", userMouseDown);
    viewerJ.bind("touchmove", userMouseMove);
    viewerJ.bind("touchend", userMouseUp);
    viewerJ.bind('dblclick', userDoubleClick);

    viewerJ.bind('contextmenu', function () { return false });
});
function userDoubleClick(e) {
    var pointDetails = DicomImageViewer.getPointInfo(e);
    pointDetails.viewer.data.multiRows = 1;
    pointDetails.viewer.data.multiColumns = 1;
    pointDetails.viewer.data.currentIndex = pointDetails.image.data.n;
    pointDetails.image.data.zoom = 0;

    // actually do them all!
    for (imageID in pointDetails.viewer.data.images) {

        pointDetails.viewer.data.images[imageID].zoom = 0;
    }

    DicomImageViewer.RenderHtml(pointDetails.viewer)
}
function userMouseDown(e) {
    e.preventDefault();
    var pointDetails = DicomImageViewer.getPointInfo(e);

    if (pointDetails.image !== null) // i.e. an image
    {
        this.lastpoint = pointDetails;
        this.firstpoint = pointDetails;
        this.mouseImage = pointDetails.image;
        this.button = pointDetails.button;
    }
}

function userMouseUp(e) {
    e.preventDefault();

    if (typeof this.lastpoint != 'undefined' && this.lastpoint !== null) {
        this.lastpoint = undefined;
        this.mouseImage.render(this);
    }
}

function userMouseMove(e) {
    var zr;
    e.preventDefault();
    if (typeof this.lastpoint != 'undefined' && this.lastpoint !== null) {

        var pointDetails = DicomImageViewer.getPointInfo(e, this.lastpoint);
        var image = this.mouseImage;

        if (pointDetails.imagediv === null)
            return;

        if (pointDetails.nPoints == 2 && this.lastpoint.nPoints === 2) {

            var d1 = DicomImageViewerUtils.distance(this.lastpoint.touches, 0, 1);
            var d2 = DicomImageViewerUtils.distance(pointDetails.touches, 0, 1);

            var c1 = DicomImageViewerUtils.centre(this.lastpoint.touches, 0, 1);
            var c2 = DicomImageViewerUtils.centre(pointDetails.touches, 0, 1);

            zr = d2 / d1;
            image.zoomAt(zr, c1);

            image.data.scroll.X += c2.X - c1.X;
            image.data.scroll.Y += c2.Y - c1.Y;

        }
        else if (this.button === 1 || this.button === 0) {
            image.data.width += pointDetails.dX; // (pointDetails.X - this.lastpoint.X);
            image.data.level += pointDetails.dY; // (pointDetails.Y - this.lastpoint.Y);
        }
        else if (this.button === 2) {
            zr = (1 - (pointDetails.Y - this.lastpoint.Y) / 100);
            image.zoomAt(zr, this.firstpoint);
        }

        else {
            image.data.scroll.X += pointDetails.dX; // - this.lastpoint.X);
            image.data.scroll.Y += pointDetails.dY; // - this.lastpoint.Y);
        }

        this.lastpoint = pointDetails;

        image.render(this);
    }
}

function userChangeImage(n) {
    var viewer = $('.DicomWebViewer')[0];
    var newIndex = viewer.data.currentIndex + n;
    if (newIndex < viewer.data.totalImages && newIndex >= 0)             // Checking array bounds    
    {
        viewer.data.currentIndex = newIndex;
        DicomImageViewer.RenderHtml(viewer);
    }
}
function userSetFormat(r,c) {
    var viewer = $('.DicomWebViewer')[0];
    viewer.data.multiRows = r;
    viewer.data.multiColumns = c;

    for (var i in viewer.data.images)
        viewer.data.images[i].zoom = 0;

    DicomImageViewer.RenderHtml(viewer);
}